import urwid
import os


def menu():
    items = os.listdir(".")
    items.sort(key=lambda f: (os.path.isdir(f), f))
    items = [".."] + items

    body = [urwid.Text('File browser'), urwid.Divider()]
    for c in items:
        button = urwid.Button(c)
        urwid.connect_signal(button, 'click', item_chosen, c)
        body.append(urwid.AttrMap(button, None, focus_map='reversed'))
    return urwid.ListBox(urwid.SimpleFocusListWalker(body))

def show(filename):
    data = open(filename).read()
    response = urwid.Text([data])
    done = urwid.Button('Ok')
    urwid.connect_signal(done, 'click', exitshow)
    return urwid.Filler(urwid.Pile([response,
        urwid.AttrMap(done, None, focus_map='reversed')]))

def exitshow(button):
    main.original_widget = menu()


def item_chosen(button, choice):
    if os.path.isdir(choice):
        os.chdir(choice)
        main.original_widget = menu()
    else:
        main.original_widget = show(choice)


main = urwid.Padding(menu(), left=2, right=2)

top = urwid.Overlay(main, urwid.SolidFill('\N{MEDIUM SHADE}'),
    align='center', width=('relative', 80),
    valign='middle', height=('relative', 80),
    min_width=20, min_height=9)

urwid.MainLoop(top, palette=[('reversed', 'standout', '')]).run()